package xpug.kata.birthday_greetings;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import java.util.Arrays;
import java.util.List;

import org.junit.Test;


public class OnTest {

	@Test
	public void sholdCollectItemsMathcingAPredicate() throws Exception {
		assertEquals(Arrays.asList(2, 6), On.items(Arrays.asList(2, 3, 6)).collect(new Even()));
	}
	
	@Test
	public void shouldFindAnItemMathingAPredicate() throws Exception {
		assertEquals(2, On.items(Arrays.asList(1, 2, 4, 5)).findFirst(new Even()));
	}
	
	@Test
	public void shouldReturnNullIfNotMatchingItemFound() throws Exception {
		assertNull(On.items(Arrays.asList(1, 3, 5)).findFirst(new Even()));
	}
	
	@Test
	public void shouldRejectItemsNotMathingAPredicate() throws Exception {
		assertEquals(Arrays.asList(1, 5), On.items(Arrays.asList(1, 2, 5, 4)).reject(new Even()));
	}
	
	@Test
	public void shouldDetectIfAMatchingItemIsFound() throws Exception {
		assertTrue(On.items(2, 5).contains(new Even()));
	}
	
	@Test
	public void shouldApplyTransformationOnEacheItem() throws Exception {
		assertEquals(Arrays.asList(2, 4, 6), On.items(1, 2, 3).apply(new Doubler()));
	}
	
	@Test
	public void shouldCollectEmailFromEmployees() throws Exception {
		String anyDate = "01/01/2000";
		List<Employee> employees = Arrays.asList(
				new Employee(null, null, anyDate, "me@localhost"),
				new Employee(null, null, anyDate, "you@localhost")
		);
		
		assertEquals(Arrays.asList("me@localhost", "you@localhost"), On.items(employees).apply(new Email()));
	}
}
