package xpug.kata.birthday_greetings;

import static java.util.Arrays.asList;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

public class SMTPGreetingsFacadeAdapter implements GreetingsFacade {
	
	private final String smtpHost;
	private final int smtpPort;
	private final String sender;

	public SMTPGreetingsFacadeAdapter(String smtpHost, int smtpPort, String sender) {
		this.smtpHost = smtpHost;
		this.smtpPort = smtpPort;
		this.sender = sender;
	}

	void sendMessage(String subject, String body, String recipient)
			throws AddressException, MessagingException {
		System.out.println("Email sent to: " + asList(sender, subject, body, recipient));

		// Create a mail session
		java.util.Properties props = new java.util.Properties();
		props.put("mail.smtp.host", smtpHost);
		props.put("mail.smtp.port", "" + smtpPort);
		Session session = Session.getDefaultInstance(props, null);

		// Construct the message
		Message msg = new MimeMessage(session);
		msg.setFrom(new InternetAddress(sender));
		msg.setRecipient(Message.RecipientType.TO, new InternetAddress(
				recipient));
		msg.setSubject(subject);
		msg.setText(body);

		// Send the message
		Transport.send(msg);
	}

	public void send(Greeting greeting) throws AddressException, MessagingException {
		sendMessage(greeting.getSubject(), greeting.getBody(), greeting.getReceiver());
	}

	
}
